#include <hxcpp.h>

#ifndef INCLUDED_snow_types_SystemEventType
#include <snow/types/SystemEventType.h>
#endif
#ifndef INCLUDED_snow_types_SystemEvents
#include <snow/types/SystemEvents.h>
#endif
namespace snow{
namespace types{

Void SystemEvents_obj::__construct()
{
	return null();
}

//SystemEvents_obj::~SystemEvents_obj() { }

Dynamic SystemEvents_obj::__CreateEmpty() { return  new SystemEvents_obj; }
hx::ObjectPtr< SystemEvents_obj > SystemEvents_obj::__new()
{  hx::ObjectPtr< SystemEvents_obj > result = new SystemEvents_obj();
	result->__construct();
	return result;}

Dynamic SystemEvents_obj::__Create(hx::DynamicArray inArgs)
{  hx::ObjectPtr< SystemEvents_obj > result = new SystemEvents_obj();
	result->__construct();
	return result;}

int SystemEvents_obj::se_unknown;

int SystemEvents_obj::se_init;

int SystemEvents_obj::se_ready;

int SystemEvents_obj::se_update;

int SystemEvents_obj::se_shutdown;

int SystemEvents_obj::se_window;

int SystemEvents_obj::se_input;

int SystemEvents_obj::se_quit;

int SystemEvents_obj::se_app_terminating;

int SystemEvents_obj::se_app_lowmemory;

int SystemEvents_obj::se_app_willenterbackground;

int SystemEvents_obj::se_app_didenterbackground;

int SystemEvents_obj::se_app_willenterforeground;

int SystemEvents_obj::se_app_didenterforeground;

int SystemEvents_obj::se_file;

::snow::types::SystemEventType SystemEvents_obj::typed( int type){
	HX_STACK_FRAME("snow.types.SystemEvents","typed",0x07467f24,"snow.types.SystemEvents.typed","snow/types/Types.hx",544,0x72b41ce7)
	HX_STACK_ARG(type,"type")
	HX_STACK_LINE(546)
	if (((type == ::snow::types::SystemEvents_obj::se_init))){
		HX_STACK_LINE(546)
		return ::snow::types::SystemEventType_obj::init;
	}
	HX_STACK_LINE(547)
	if (((type == ::snow::types::SystemEvents_obj::se_ready))){
		HX_STACK_LINE(547)
		return ::snow::types::SystemEventType_obj::ready;
	}
	HX_STACK_LINE(548)
	if (((type == ::snow::types::SystemEvents_obj::se_update))){
		HX_STACK_LINE(548)
		return ::snow::types::SystemEventType_obj::update;
	}
	HX_STACK_LINE(549)
	if (((type == ::snow::types::SystemEvents_obj::se_shutdown))){
		HX_STACK_LINE(549)
		return ::snow::types::SystemEventType_obj::shutdown;
	}
	HX_STACK_LINE(550)
	if (((type == ::snow::types::SystemEvents_obj::se_window))){
		HX_STACK_LINE(550)
		return ::snow::types::SystemEventType_obj::window;
	}
	HX_STACK_LINE(551)
	if (((type == ::snow::types::SystemEvents_obj::se_input))){
		HX_STACK_LINE(551)
		return ::snow::types::SystemEventType_obj::input;
	}
	HX_STACK_LINE(553)
	if (((type == ::snow::types::SystemEvents_obj::se_quit))){
		HX_STACK_LINE(553)
		return ::snow::types::SystemEventType_obj::quit;
	}
	HX_STACK_LINE(554)
	if (((type == ::snow::types::SystemEvents_obj::se_app_terminating))){
		HX_STACK_LINE(554)
		return ::snow::types::SystemEventType_obj::app_terminating;
	}
	HX_STACK_LINE(555)
	if (((type == ::snow::types::SystemEvents_obj::se_app_lowmemory))){
		HX_STACK_LINE(555)
		return ::snow::types::SystemEventType_obj::app_lowmemory;
	}
	HX_STACK_LINE(556)
	if (((type == ::snow::types::SystemEvents_obj::se_app_willenterbackground))){
		HX_STACK_LINE(556)
		return ::snow::types::SystemEventType_obj::app_willenterbackground;
	}
	HX_STACK_LINE(557)
	if (((type == ::snow::types::SystemEvents_obj::se_app_didenterbackground))){
		HX_STACK_LINE(557)
		return ::snow::types::SystemEventType_obj::app_didenterbackground;
	}
	HX_STACK_LINE(558)
	if (((type == ::snow::types::SystemEvents_obj::se_app_willenterforeground))){
		HX_STACK_LINE(558)
		return ::snow::types::SystemEventType_obj::app_willenterforeground;
	}
	HX_STACK_LINE(559)
	if (((type == ::snow::types::SystemEvents_obj::se_app_didenterforeground))){
		HX_STACK_LINE(559)
		return ::snow::types::SystemEventType_obj::app_didenterforeground;
	}
	HX_STACK_LINE(560)
	if (((type == ::snow::types::SystemEvents_obj::se_file))){
		HX_STACK_LINE(560)
		return ::snow::types::SystemEventType_obj::file;
	}
	HX_STACK_LINE(562)
	return ::snow::types::SystemEventType_obj::unknown;
}


STATIC_HX_DEFINE_DYNAMIC_FUNC1(SystemEvents_obj,typed,return )


SystemEvents_obj::SystemEvents_obj()
{
}

Dynamic SystemEvents_obj::__Field(const ::String &inName,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"typed") ) { return typed_dyn(); }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"se_init") ) { return se_init; }
		if (HX_FIELD_EQ(inName,"se_quit") ) { return se_quit; }
		if (HX_FIELD_EQ(inName,"se_file") ) { return se_file; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"se_ready") ) { return se_ready; }
		if (HX_FIELD_EQ(inName,"se_input") ) { return se_input; }
		break;
	case 9:
		if (HX_FIELD_EQ(inName,"se_update") ) { return se_update; }
		if (HX_FIELD_EQ(inName,"se_window") ) { return se_window; }
		break;
	case 10:
		if (HX_FIELD_EQ(inName,"se_unknown") ) { return se_unknown; }
		break;
	case 11:
		if (HX_FIELD_EQ(inName,"se_shutdown") ) { return se_shutdown; }
		break;
	case 16:
		if (HX_FIELD_EQ(inName,"se_app_lowmemory") ) { return se_app_lowmemory; }
		break;
	case 18:
		if (HX_FIELD_EQ(inName,"se_app_terminating") ) { return se_app_terminating; }
		break;
	case 25:
		if (HX_FIELD_EQ(inName,"se_app_didenterbackground") ) { return se_app_didenterbackground; }
		if (HX_FIELD_EQ(inName,"se_app_didenterforeground") ) { return se_app_didenterforeground; }
		break;
	case 26:
		if (HX_FIELD_EQ(inName,"se_app_willenterbackground") ) { return se_app_willenterbackground; }
		if (HX_FIELD_EQ(inName,"se_app_willenterforeground") ) { return se_app_willenterforeground; }
	}
	return super::__Field(inName,inCallProp);
}

Dynamic SystemEvents_obj::__SetField(const ::String &inName,const Dynamic &inValue,bool inCallProp)
{
	switch(inName.length) {
	case 7:
		if (HX_FIELD_EQ(inName,"se_init") ) { se_init=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"se_quit") ) { se_quit=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"se_file") ) { se_file=inValue.Cast< int >(); return inValue; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"se_ready") ) { se_ready=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"se_input") ) { se_input=inValue.Cast< int >(); return inValue; }
		break;
	case 9:
		if (HX_FIELD_EQ(inName,"se_update") ) { se_update=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"se_window") ) { se_window=inValue.Cast< int >(); return inValue; }
		break;
	case 10:
		if (HX_FIELD_EQ(inName,"se_unknown") ) { se_unknown=inValue.Cast< int >(); return inValue; }
		break;
	case 11:
		if (HX_FIELD_EQ(inName,"se_shutdown") ) { se_shutdown=inValue.Cast< int >(); return inValue; }
		break;
	case 16:
		if (HX_FIELD_EQ(inName,"se_app_lowmemory") ) { se_app_lowmemory=inValue.Cast< int >(); return inValue; }
		break;
	case 18:
		if (HX_FIELD_EQ(inName,"se_app_terminating") ) { se_app_terminating=inValue.Cast< int >(); return inValue; }
		break;
	case 25:
		if (HX_FIELD_EQ(inName,"se_app_didenterbackground") ) { se_app_didenterbackground=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"se_app_didenterforeground") ) { se_app_didenterforeground=inValue.Cast< int >(); return inValue; }
		break;
	case 26:
		if (HX_FIELD_EQ(inName,"se_app_willenterbackground") ) { se_app_willenterbackground=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"se_app_willenterforeground") ) { se_app_willenterforeground=inValue.Cast< int >(); return inValue; }
	}
	return super::__SetField(inName,inValue,inCallProp);
}

void SystemEvents_obj::__GetFields(Array< ::String> &outFields)
{
	super::__GetFields(outFields);
};

static ::String sStaticFields[] = {
	HX_CSTRING("se_unknown"),
	HX_CSTRING("se_init"),
	HX_CSTRING("se_ready"),
	HX_CSTRING("se_update"),
	HX_CSTRING("se_shutdown"),
	HX_CSTRING("se_window"),
	HX_CSTRING("se_input"),
	HX_CSTRING("se_quit"),
	HX_CSTRING("se_app_terminating"),
	HX_CSTRING("se_app_lowmemory"),
	HX_CSTRING("se_app_willenterbackground"),
	HX_CSTRING("se_app_didenterbackground"),
	HX_CSTRING("se_app_willenterforeground"),
	HX_CSTRING("se_app_didenterforeground"),
	HX_CSTRING("se_file"),
	HX_CSTRING("typed"),
	String(null()) };

#if HXCPP_SCRIPTABLE
static hx::StorageInfo *sMemberStorageInfo = 0;
#endif

static ::String sMemberFields[] = {
	String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(SystemEvents_obj::__mClass,"__mClass");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_unknown,"se_unknown");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_init,"se_init");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_ready,"se_ready");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_update,"se_update");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_shutdown,"se_shutdown");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_window,"se_window");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_input,"se_input");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_quit,"se_quit");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_app_terminating,"se_app_terminating");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_app_lowmemory,"se_app_lowmemory");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_app_willenterbackground,"se_app_willenterbackground");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_app_didenterbackground,"se_app_didenterbackground");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_app_willenterforeground,"se_app_willenterforeground");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_app_didenterforeground,"se_app_didenterforeground");
	HX_MARK_MEMBER_NAME(SystemEvents_obj::se_file,"se_file");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatics(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_unknown,"se_unknown");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_init,"se_init");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_ready,"se_ready");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_update,"se_update");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_shutdown,"se_shutdown");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_window,"se_window");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_input,"se_input");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_quit,"se_quit");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_app_terminating,"se_app_terminating");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_app_lowmemory,"se_app_lowmemory");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_app_willenterbackground,"se_app_willenterbackground");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_app_didenterbackground,"se_app_didenterbackground");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_app_willenterforeground,"se_app_willenterforeground");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_app_didenterforeground,"se_app_didenterforeground");
	HX_VISIT_MEMBER_NAME(SystemEvents_obj::se_file,"se_file");
};

#endif

Class SystemEvents_obj::__mClass;

void SystemEvents_obj::__register()
{
	hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.types.SystemEvents"), hx::TCanCast< SystemEvents_obj> ,sStaticFields,sMemberFields,
	&__CreateEmpty, &__Create,
	&super::__SGetClass(), 0, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatics
#endif
#ifdef HXCPP_SCRIPTABLE
    , sMemberStorageInfo
#endif
);
}

void SystemEvents_obj::__boot()
{
	se_unknown= (int)0;
	se_init= (int)1;
	se_ready= (int)2;
	se_update= (int)3;
	se_shutdown= (int)4;
	se_window= (int)5;
	se_input= (int)6;
	se_quit= (int)7;
	se_app_terminating= (int)8;
	se_app_lowmemory= (int)9;
	se_app_willenterbackground= (int)10;
	se_app_didenterbackground= (int)11;
	se_app_willenterforeground= (int)12;
	se_app_didenterforeground= (int)13;
	se_file= (int)14;
}

} // end namespace snow
} // end namespace types
